#include "Common.ch"

#define WdAlertsNone 0
#define WdAlertsAll  -1
#define WdAlertsMessageBox -2

  #include "activex.ch"
  #include "excel.ch"
  #pragma library( "ascom10.lib" )

Static nBMCount := 0

//////////////////////////////////////////////////////////////////////
// Sucht ein Lesezeichen cBM ueber seinen Namen in einer Sammlung
// (Collection) von Lesezeichen. Diesem Lesezeichen wird dann ein
// neuer Wert (cValue) zugewiesen.
//////////////////////////////////////////////////////////////////////

STATIC FUNCTION ReplaceBookmark(oBM,cBM,cValue)
Local lRet := oBM:Exists(cBM) .and. nBMCount > 0
IF(lRet)
  oBM:Item(cBM):Range:Text := cValue
  nBMCount--
ENDIF
RETURN(lRet)


//////////////////////////////////////////////////////////////////////
// Oeffnet ein MS Word-Dokument und ersetzt die Lesezeichen mit
// Werten, die in der Liste aData uebergeben wurden. Das Ergebnis
// wird dann auf die Festplatte geschrieben.
//////////////////////////////////////////////////////////////////////
FUNCTION WordFillDocument(cFile,cSaveAs,lPrint,lDruOrEdit,nCopies,lVorschau, nSchacht1, nSchacht2, nOrientation, cPrinter)
Local oWord,;
      oBM,;
      oDoc, ;
      oDruckerSettings, ;
      lWordFinished := .f., ;
      lFound := .f., ;
      nEvent := 0, ;
      mp1 := 0, ;
      mp2 := 0, ;
      nFirstTrayID := 0, ;
      nOtherTrayID := 0, ;
      lBackground := .f., ;
      cOldPrinter , ;
      nOldOrientation := 0, ;
      oErrBlock := ErrorBlock({|| break() }), ;
      WDFormatDocument := 100, ;   // RTF File extension *.doc
      cBriefform := "DOC"
      mess1 := 'Microsoft Word ist nicht installiert', ;
      mess1029 := 'nicht gefunden!', ;
      mess1030 := 'Datei:'

Local canschrift := "OK "+chr13)+"Abrechnungssysteme"+chr(13)+"K. Overhage"+chr(13)+;
                    "Hopfenstr. 18"+chr(13)+"73430 Aalen", ;
      C_KDNR := "1000", ;
      m_name1 := "OK", ;                   // Kunde Name 1
      m_name2 := "Abrechnungssysteme", ;   // Kunde Name 2
      m_name3 := "K. Overhage", ;          // Kunde Name 3
      m_name4 := " ", ;                    // Kunde Name 4
      m_strasse := "Hopfenstr. 18", ;      // Strasse des Kunden
      m_land := "D", ;                     // Land des Kunden
      m_plz := 73430, ;                    // Postleitzahl Kunde
      m_ort := "Aalen", ;                  // Ort des Kunden
      m_kdbic := "hh", ;                  // Bic Kunde
      m_kdiban := "DEXXXXXXXXXXXXXXXX"     // Iban Kunde


default lDruOrEdit to .f.
default lPrint to .f.
nCopies to 1
default lVorschau to .f.
default nSchacht1 to 0
default nSchacht2 to 0
default nOrientation to 0  // Portrait = Normal

lFound := Fexists(cFile)
IF !lFound .and. cBriefform = "DOCX"
   cFile := strtran(cFile, ".DOCX", ".DOC")
   lFound := Fexists(cFile)
ENDIF
IF !lFound
   msgbox(mess1030+" "+cFile+" "+mess1029)
   return .f.
ENDIF

IF(ValType(cSaveAs)=="C")
   if Rat( ".",cSaveAs) < 1
      cSaveAs := cSaveAs + "."+cBriefform
   endif
ENDIF


// Erzeugen einer ActiveX-Komponente
oWord := CreateObject("Word.Application")
IF Empty( oWord )
   oWord := CreateObject("opendocument.WriterDocument.1")
ENDIF
IF Empty( oWord )
   MsgBox( mess1 )
   Return .f.
ENDIF
if lDruOrEdit
   oWord := oWord:dynamicCast(ActiveXObject())
   oWord:Quit := {||lWordFinished := .T.}
   oWord:Visible := .T.
   lWordFinished := .F.
else
   oWord:Visible := .F.
   oWord:DisplayAlerts := WdAlertsNone
endif

// Oeffnen eines Word-Dokuments und Zugriff auf
// eine Sammlung von Lesezeichen
oWord:documents:open( cFile, .f., .t. )   // Keine Konvertierungen anzeigen
oDoc := oWord:ActiveDocument              // und schreibgeschuetzt
oBM  := oDoc:Bookmarks
oDruckerSettings := oDoc:PageSetup

nBMCount := oBM:Count()

// Ersetzen des Lesezeichens durch einen neuen Wert

// Kundendaten
ReplaceBookmark(oBM , "canschrift"  , canschrift )    // Adressfeld
ReplaceBookmark(oBM , "C_KDNR"      , c_kdnr )    // Kundenummer
ReplaceBookmark(oBM , "M_KDNR"      , c_kdnr )    // Kundenummer
ReplaceBookmark(oBM , "M_NAME1"     , rtrim(m_name1) )   // Kunde Name 1
ReplaceBookmark(oBM , "M_NAME2"     , rtrim(m_name2) )   // Kunde Name 2
ReplaceBookmark(oBM , "M_NAME3"     , rtrim(m_name3) )   // Kunde Name 3
ReplaceBookmark(oBM , "M_NAME4"     , rtrim(m_name4) )   // Kunde Name 4
ReplaceBookmark(oBM , "M_STRASSE"   , rtrim(m_strasse) ) // Strasse des Kunden
ReplaceBookmark(oBM , "M_LAND"      , rtrim(m_land) )    // Land des Kunden
ReplaceBookmark(oBM , "M_PLZ"       , strzero(m_plz,5) ) // Postleitzahl Kunde
ReplaceBookmark(oBM , "M_ORT"       , rtrim(m_ort) )     // Ort des Kunden
ReplaceBookmark(oBM , "DATUM"       , DToC(Date()) )  // Tagesdatum
ReplaceBookmark(oBM , "M_DATUM"     , DToC(Date()) )  // Tagesdatum
ReplaceBookmark(oBM , "M_KDBIC"     , m_kdbic )   // Bic Kunde
ReplaceBookmark(oBM , "M_KDIBAN"    , m_kdiban )  // Iban Kunde


// Speichern des Ergebnisses
IF (ValType(cSaveAs)=="C")
   oDoc:saveas(cSaveAs)
ENDIF


// Sichern der aktuellen Einstellungen
nFirstTrayID := oDruckerSettings:FirstPageTray
if nSchacht2 > 0
   nOtherTrayID := oDruckerSettings:OtherPagesTray
endif
nOldOrientation := oDruckerSettings:Orientation
//  msgbox(str(nOldOrientation))
// Setzen der gewnschten Werte
// Returns or sets the paper tray to use for the first page
// of a document or section.
if nSchacht1 > 0
   oDruckerSettings:FirstPageTray := nSchacht1
endif

// Returns or sets the paper tray to be used for all
// but the first page of a document or section.
if nSchacht2 > 0
   oDruckerSettings:OtherPagesTray := nSchacht2
endif

// Returns or sets the orientation of the page.
//  BEGIN SEQUENCE
//  oDruckerSettings:Orientation := nOrientation
//  END SEQUENCE
//  ErrorBlock(oErrBlock)

// True for Microsoft Word to print a document in a series
// of booklets so the printed pages can be folded and
// read as a book.
// oDruckerSettings:BookFoldPrinting :=

// True for Microsoft Word to reverse the printing order for book
// fold printing of bidirectional or Asian language documents.
// oDruckerSettings:BookFoldRevPrinting :=

// Returns or sets the height of the page in points.
// oDruckerSettings:PageHeight :=

// Returns or sets the width of the page in points.
// oDruckerSettings:PageWidth :=

// Returns or sets the paper size
// oDruckerSettings:PaperSize :=

// Returns or sets the distance (in points) between the top edge
// of the page and the top boundary of the body text.
// oDruckerSettings:TopMargin :=

// Returns or sets the distance (in points) between the left edge
// of the page and the left boundary of the body text.
// oDruckerSettings:LeftMargin :=

// Returns or sets the distance (in points) between the bottom edge
// of the page and the bottom boundary of the body text.
// oDruckerSettings:BottomMargin :=

// Returns or sets the distance (in points) between the right edge
// of the page and the right boundary of the body text.
// oDruckerSettings:RightMargin :=

// True if Microsoft Word prints the specified document two pages
// per sheet.
// oDruckerSettings:TwoPagesOnOne :=


// Optionales Ausgeben auf dem Standarddrucker
// PrintOut(Background, Append, Range, OutputFileName, From, To, Item, Copies, Pages, PageType, PrintToFile, Collate, FileName, ActivePrinterMacGX, ManualDuplexPrint, PrintZoomColumn, PrintZoomRow, PrintZoomPaperWidth, PrintZoomPaperHeight)
IF (ValType(lPrint)=="L" .AND. lPrint)
   if lVorschau
      oDoc:PrintPreview()
   else
      cOldPrinter := oWord:ActivePrinter := rtrim(cPrinter)
      oDoc:PrintOut(lBackground,NIL,NIL,NIL,NIL,NIL,NIL,nCopies)
      oWord:ActivePrinter := cOldPrinter
   endif
ENDIF

if lDruOrEdit
   Do WHILE !lWordFinished
      // Just wait
      nEvent := AppEvent( @mp1, @mp2, , 1)
   EndDo
else
   // Schliessen des Dokuments und zerstoeren das
   // ActiveX-Objektes.
   // gesicherte Einstellungen zurcksetzen
   oDruckerSettings:FirstPageTray := nFirstTrayID
   if nSchacht2 > 0
      oDruckerSettings:OtherPagesTray := nOtherTrayID
   endif
   oDruckerSettings:Orientation := nOldOrientation
   oDoc:close()
   sleep(0)
   oWord:Quit()
   sleep(0)
endif
oWord:destroy()
sleep(0)
RETURN .t.


